/* MLSystemInformation.h created by mlaster on Thu 13-Nov-1997 */

#import <Foundation/Foundation.h>
#import <mach/mach.h>

extern NSString *performanceUpdateNotification;

@interface MLSystemInformation : NSObject
{
    struct host_load_info load_info;
    NSTimer *timer;
}

- (id) init;
- (id) initWithInterval:(NSTimeInterval)anInterval;	// D.I.
- (void) dealloc;

// accessor methods
- (void) setTimer:(NSTimer *)newTimer;
- (NSTimer *) timer;

// statistics at 1, 5, and 15 minute running averages
- (double) runQueue1;
- (double) runQueue5;
- (double) runQueue15;
- (double) machFactor1;
- (double) machFactor5;
- (double) machFactor15;

// notification receivers
- (void) timerTick:(NSInvocation *)anInvocation;

- (void) retreiveLoadInformation;

@end
